authentication/urls.py
from django.contrib.auth.views import LogoutView
from django.urls import path, include

from authentication import views
from authentication.api.router import router
from sgp import settings

app_name = 'authentication'
urlpatterns = [
    path('', views.SignInView.as_view(), name='login'),
    path('api/', include(router.urls)),
    path('api-auth/', include('rest_framework.urls')),
    path('logout/', LogoutView.as_view(), {'next_page': settings.LOGOUT_REDIRECT_URL}, name='logout'),
    path('register/', views.SignUpView.as_view(), name='register'),
    path('redirect-session', views.redirect_session, name='redirect_session'),
]

sgp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static

from sgp import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('authentication.urls')),
    path('administrator/', include('administrator.urls')),
    path('evaluator/', include('evaluator.urls')),
    path('projects/', include('projects.urls')),
    path('writer/', include('writer.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

writer/urls.py
from django.urls import path

from writer import views

app_name = 'writer'
urlpatterns = [
    path('', views.ProjectsDashboardView.as_view(), name='projects'),
    path('profile/', views.UserProfileView.as_view(), name='profile'),
    path('projects/edit/<int:id>', views.ProjectsEditView.as_view(), name='edit_project'),
    path('projects/questions/<int:id>', views.ProjectQuestionsView.as_view(), name='get_questions_project'),
    path('projects/questions-detail/<int:id>', views.ProjectDescriptionQuestionView.as_view(),
         name='get_question_detail'),
    path('projects/add/', views.AddProjectView.as_view(), name='add_project'),
    path('projects/questions/add/', views.AddQuestionsProjectView.as_view(), name='add_questions'),
]

writer/models.py
from django.db import models

# Create your models here.

writer/views.py
import json

from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Q
from django.http import JsonResponse
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views import View

from authentication.models import UserInformation
from core.models import Category
from projects.models import Project, Question
from writer.writer_controller import WriterController


class UserProfileView(LoginRequiredMixin, View):
    template_name = "writer/profile.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        return render(request, self.template_name, {
            'user': user,
        })

    def post(self, request, *args, **kwargs):
        try:
            user_info = UserInformation.objects.get(user=request.user)
            username = request.POST.get('username')
            first_name = request.POST.get('first_name')
            last_name = request.POST.get('last_name')
            email = request.POST.get('email')
            identification = request.POST.get('identification')
            cellphone = request.POST.get('cellphone')
            terms_conditions = request.POST.get('terms_conditions')
            biography = request.POST.get('biography')

            user_info.biography = biography
            user_info.identification = identification
            user_info.cellphone = cellphone
            user_info.save()

            user = user_info.user
            user.first_name = first_name
            user.last_name = last_name
            user.save()

            messages.info(request, "Información personal actualizada")
            return redirect(reverse_lazy('writer:profile'))
        except Exception as e:
            messages.error(request, "Tenemos un error al intentar guardar tu información. "
                                    "Por favor verifica que los campos estén completos")
            return redirect(reverse_lazy('writer:profile'))


class ProjectsDashboardView(LoginRequiredMixin, View):
    template_name = "writer/projects_dashboard.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        qualified = Project.objects.filter(status=Project.QUALIFIED).count()
        send = Project.objects.filter(status=Project.SEND).count()
        for_correction = Project.objects.filter(
            Q(status=Project.FOR_CORRECTION) | Q(status=Project.DRAFT) | Q(status=Project.CREATED)
        ).count()
        in_correction = Project.objects.filter(status=Project.IN_CORRECTION).count()
        total_projects = Project.objects.filter(author_id=request.user.id).count()
        return render(request, self.template_name, {
            'user': user,
            'qualified': qualified,
            'send': send,
            'for_correction': for_correction,
            'in_correction': in_correction,
            'total_projects': total_projects,
        })


class ProjectsEditView(LoginRequiredMixin, View):
    template_name = "writer/project_edit.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        project = Project.objects.get(id=kwargs.get('id'), author_id=request.user.id)
        categories_project = [{'id': cat.id, 'name': cat.name} for cat in project.category.only('id', 'name')]
        categories = Category.objects.all()
        return render(request, self.template_name, {
            'user': user,
            'project': project,
            'categories_project': categories_project,
            'categories': categories,
            'count_items': Question.objects.filter(
                project_id=kwargs.get('id'),
                project__author_id=request.user.id
            ).count()
        })

    def delete(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = Project.objects.get(
            id=data.get('id'),
            author_id=request.user.id
        )
        query.delete()
        return JsonResponse(
            status=200,
            data={
                'id': query.id,
                'message': 'Proyecto eliminado',
                'alert': 'info'
            }
        )


class ProjectQuestionsView(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        query = Question.objects.filter(
            project_id=kwargs.get('id'),
            project__author_id=request.user.id
        ).only('id', 'title')
        questions = [{'id': q.id, 'title': q.title} for q in query]
        return JsonResponse(status=200, data={'questions': questions})


class ProjectDescriptionQuestionView(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        query = Question.objects.get(
            id=kwargs.get('id'),
            project__author_id=request.user.id
        )
        return JsonResponse(status=200, data={'id': query.id, 'title': query.title, 'answer': query.answer})

    def delete(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = WriterController.delete_question(data, request)
        return JsonResponse(
            status=200,
            data={
                'id': query.id,
                'message': 'Item eliminado',
                'alert': 'info'
            }
        )

    def put(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = WriterController.update_questions(data, request)
        return JsonResponse(
            status=200,
            data={
                'item': {'id': query.id, 'title': query.title},
                'message': 'Item actualizado exitosamente'
            }
        )


class AddProjectView(LoginRequiredMixin, View):
    template_name = "writer/project_add.html"

    def get(self, request, *args, **kwargs):
        categories = Category.objects.all()
        return render(request, self.template_name, {'categories': categories})

    def post(self, request, *args, **kwargs):
        data = json.loads(request.body)
        categories = Category.objects.filter(id__in=data['categories']).only('id').values_list('id', flat=True)
        project = Project.objects.create(
            author=request.user,
            title=data['title'],
            description=data['description'],
            status=Project.CREATED,
            created_by=request.user.id
        )
        for c in categories:
            project.category.add(c)

        return JsonResponse(
            status=200,
            data={
                'id': project.id,
                'message': 'Proyecto creado exitosamente',
                'alert': 'success'
            }
        )

    def put(self, request, *args, **kwargs):
        data = json.loads(request.body)
        id_project = data.get('id_project', None)
        if not id_project:
            return JsonResponse(status=400, data={'message': 'Id proyecto no identificado', 'alert': 'warning'})

        message, alert, project_id = WriterController.update_project(id_project, data)

        return JsonResponse(
            status=200,
            data={
                'message': message,
                'alert': alert,
                'id': project_id
            }
        )


class AddQuestionsProjectView(LoginRequiredMixin, View):
    def post(self, request, *args, **kwargs):
        data = json.loads(request.body)
        id_project = data.get('id_project', None)
        if not id_project:
            return JsonResponse(
                status=400,
                data={
                    'message': 'Id proyecto no identificado',
                    'alert': 'warning'
                }
            )

        questions = list()
        for q in data.get('questions', None):
            if q.get('id', None):
                if q.get('delete') == 1:
                    query = WriterController.delete_question(q, request)
                else:
                    query = WriterController.update_questions(q, request)
            else:
                query = Question.objects.create(
                    title=q.get('title'),
                    answer=q.get('answer'),
                    project_id=id_project
                )
            questions.append({
                'id': query.id,
                'id_tmp': q.get('id_tmp'),
                'delete': q.get('delete'),
                'title': query.title,
                'answer': query.answer
            })
        return JsonResponse(
            status=200,
            data={
                'questions': questions,
                'message': 'Items creados exitosamente',
                'alert': 'success'
            }
        )

writer/templates/writer/base_writer.html
{% extends 'writer/base.html' %}
{% load static writer_tag %}


{% block _css %}
    <style>
        .danger-color {
            color: #e65252;
        }
        .href-view-project {
            display: flex!important;
            justify-content: space-between;
        }
        .qualification {
            font-size: 12px;
            font-weight: bold;
            margin-right: 5px;
        }
        .qualification.approved {
            color: #4d9121;
        }
        .qualification.reapproved {
            color: #e65252;
        }
        @media (max-width: 1650px) {
            body.with-content-panel .content-box {
                padding-left: 2rem!important;
            }
        }
    </style>

{% endblock %}

{% block content_writer %}
    <div class="todo-app-w">
        <!--START - To Do SIDEBAR-->
        <div class="todo-sidebar">
            <div class="todo-sidebar-section">
                <div class="todo-sidebar-section-contents">
                    <ul class="projects-list">
                        <li class="add-new-project">
                            <a href="{% url 'writer:add_project' %}">Agregar un nuevo proyecto</a>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="todo-sidebar-section">
                <h4 class="todo-sidebar-section-header">
                    <span><a href="{% url 'writer:projects' %}">Mis proyectos</a></span>
                </h4>
                <div class="todo-sidebar-section-contents">
                    {% get_projects request 'draft' as projects_draft %}
                    {% include 'writer/base/menu_projects.html' with status='draft' title='En borrador' query=projects_draft icon='os-icon-documents-11' %}

                    {% get_projects request 'send' as projects_send %}
                    {% include 'writer/base/menu_projects.html' with status='send' title='Enviados' query=projects_send icon='os-icon-ui-34' %}


                    {% get_projects request 'for_correction' as projects_for_correction %}
                    {% include 'writer/base/menu_projects.html' with status='for_correction' title='Por corregir' query=projects_for_correction icon='os-icon-ui-49' %}

                    {% get_projects request 'qualified' as projects_qualified %}
                    {% include 'writer/base/menu_projects.html' with status='qualified' title='Calificados' query=projects_qualified icon='os-icon-ui-21' %}
                </div>
            </div>
        </div>
        <!--END - To Do SIDEBAR-->
        <div class="todo-content">
            {% block content_block %}{% endblock content_block %}
        </div>
    </div>

{% endblock %}

writer/templates/writer/menu.html
<li>
    <a href="{% url 'writer:projects' %}">
        <div class="icon-w">
            <div class="os-icon os-icon-delivery-box-2"></div>
        </div>
        <span>Proyectos</span>
    </a>
</li>
<li>
    <a href="{% url 'writer:profile' %}">
        <div class="icon-w">
            <div class="os-icon os-icon-user-male-circle"></div>
        </div>
        <span>Perfil</span>
    </a>
</li>
<li>
    <a href="#">
        <div class="icon-w">
            <div class="os-icon os-icon-others-43"></div>
        </div>
        <span>Notificaciones</span>
    </a>
</li>
<li>
    <a href="#">
        <div class="icon-w">
            <div class="os-icon os-icon-pencil-12"></div>
        </div>
        <span>Configuraciones</span>
    </a>
</li>
<li>
    <a href="#">
        <div class="icon-w">
            <div class="os-icon os-icon-newspaper"></div>
        </div>
        <span>PQR</span>
    </a>
</li>
<li>
    <a href="{% url 'authentication:logout' %}">
        <div class="icon-w">
            <div class="os-icon os-icon-signs-11"></div>
        </div>
        <span>Cerrar sesión</span>
    </a>
</li>

writer/templates/writer/project_add.html
{% extends 'writer/base_writer.html' %}
{% load static %}


{% block extra_css %}
    <link href="{% static 'icon_fonts_assets/batch-icons/style.css' %}" rel="stylesheet">
    <style>
        .add-item {
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
            min-height: 30%;
            width: 100%;
            opacity: .5;
            cursor: pointer;
            background-color: rgba(238, 238, 238, 0.5)
        }

        .add-item:hover {
            opacity: 1;
        }

        .add-item i {
            font-size: 3rem;
            margin-bottom: 15px;
        }

        .add-item span {
            font-size: 1.5rem;
            text-align: center;
        }

        .bg-item {
            background-color: rgba(238, 238, 238, 0.5)
        }

        a.disabled {
            pointer-events: none;
            cursor: default;
        }

        .btn-delete-item {
            position: absolute;
            right: 22px;
            top: 5px;
            padding: 12px 16px !important;
            font-weight: bold;
            background-color: #ffffff !important;
            border: 0;
            box-shadow: 0px 2px 4px rgb(126 142 177 / 12%);
            border-radius: 5px;
            z-index: 9991;
            cursor: pointer !important;
            opacity: 1;
            font-size: 10px;

        }

        .btn-delete-item span {
            font-weight: bold;
        }

        .btn-delete-item:hover {
            color: red;
        }
    </style>
{% endblock extra_css %}


{% block content_block %}
    <h4 class="todo-content-header">
        <i class="os-icon os-icon-ui-83"></i><span>Agregar un nuevo proyecto</span>
    </h4>
    <div class="all-tasks-w" id="app">
        <div class="tasks-section">
            <div class="steps">
                <div class="contents">
                    {% include 'writer/add/step_1.html' %}
                    {% include 'writer/add/step_2.html' %}
                    {% include 'writer/add/step_3.html' %}
                    {% include 'writer/step_end.html' with step=4 step_back=3 %}
                </div>
            </div>
            {% csrf_token %}
        </div>
    </div>

{% endblock %}

{% block _js %}

    <script src="https://unpkg.com/vue@3"></script>

    <script type="importmap">
      {
        "imports": {
          "vue": "https://unpkg.com/vue@3/dist/vue.esm-browser.js"
        }
      }


    </script>

    <script type="module">

    import {createApp} from 'vue'

let app = createApp({
    delimiters: ['${', '}'],
    data() {
        return {
            show_intro: false,
            items: [1],
            saved: false,
            questions: [
                {
                    'id_tmp': 1,
                    'title': '',
                    'answer': '',
                    'delete': 0,
                }
            ],
            itemEdit: {
                id: '',
                title: '',
                answer: ''
            },
            itemDelete: {
                id: '',
                title: '',
            },
            count: 1,
            id_project: null,
            title: "",
            description: "",
            categories: [],
            disableStepOne: true,
            step: 1,
            status: 'created'

        }
    },
    created() {
        window.removeItem = this.removeItem;
    },
    mounted() {
        this.enableStepActionOne();
    },
    computed: {},
    methods: {
        changeStep(step) {
            window.scrollTo({top: 0, behavior: 'smooth'});
            this.step = step
        },
        fetchProject(step) {
            let vm = this;
            fetch("{% url 'writer:add_project' %}", {
                method: vm.id_project ? "put" : "post",
                body: JSON.stringify({
                    'id_project': vm.id_project ? vm.id_project : '',
                    'title': vm.title,
                    'description': vm.description,
                    'categories': vm.categories,
                    'status': vm.status
                }),
                headers: {
                    'Content-Type': 'application/json',
                    'X-CSRFToken': document.getElementsByName('csrfmiddlewaretoken')[0].value
                }
            }).then(response => {
                if (response.status === 200) {
                    response.json()
                        .catch(error => console.log(error))
                        .then(response => {
                            console.log(response['id'])
                            vm.id_project = response['id']
                            createToast(response.message, response.alert)
                            return vm.changeStep(step)
                        });
                } else {
                    response.json()
                        .catch(error => console.log(error))
                        .then(response => {
                            console.error(response)
                        });
                }

            })
        },
        createProject() {
            this.fetchProject(2)
        },
        saveDraft(step) {
            this.status = 'draft'
            this.fetchProject(step)
            this.saveQuestions();
            createToast('Proyecto guardado como borrador exitosamente', 'info')
        },
        saveQuestions() {
            let vm = this;
            let data = []
            for (let i = 0; i < this.items.length; i++) {
                let v = this.items[i]
                let id = document.getElementById(`id-${v}`).value
                let id_tmp = document.getElementById(`id_tmp-${v}`).value
                let title = document.getElementById(`title-${v}`).value
                let answer = this.getDescription(`answer-${this.items[i]}`)
                data.push({
                    'id_tmp': id_tmp,
                    'id': id,
                    'title': title,
                    'answer': answer,
                    'delete': vm.is_delete(id_tmp),
                })
            }
            console.log(data)

            if(data) {
                fetch("{% url 'writer:add_questions' %}", {
                    method: "post",
                    body: JSON.stringify({
                        'id_project': vm.id_project,
                        'questions': data,
                    }),
                    headers: {
                        'Content-Type': 'application/json',
                        'X-CSRFToken': document.getElementsByName('csrfmiddlewaretoken')[0].value
                    }
                }).then(response => {
                    if (response.status === 200) {
                        response.json()
                            .catch(error => console.log(error))
                            .then(response => {
                                let q = response['questions'];
                                console.log(q)
                                vm.saved = true;
                                vm.questions = response['questions'];

                                createToast(response.message, response.alert)
                            });
                    } else {
                        response.json()
                            .catch(error => console.log(error))
                            .then(response => {
                                console.error(response)
                            });
                    }

                })
            }

        },
        enableStepActionOne() {
            let vm = this;
            window.setInterval(function () {
                vm.description = vm.getDescription('ckeditor-main')
                vm.categories = vm.getCategories()
                vm.disableStepOne = !(vm.title.length > 0 && vm.description.length > 0 && vm.categories.length > 0);
            }, 500);

        },
        getDescription(field) {
            if ($(`#${field}`).length) {
                return CKEDITOR.instances[field].getData()
            }
        },
        getCategories() {
            if ($('.select2').length) {
                return $("#categories").val()
            }
        },
        is_delete(id_tmp) {
            let is_delete = 0;
            this.questions.filter(item => {
                if(item.id && item.delete === 1 && parseInt(item.id_tmp) === parseInt(id_tmp)) {
                    item.delete = 1
                    is_delete = 1
                }
            });
            return is_delete;
        },
        removeItem(item_id) {
            // let el = document.getElementById(`item-${item}`)
            /*for (let i = 0; i < this.items.length; i++) {
                if (this.items[i] === parseInt(item_id)) {
                    this.items.splice(i, 1);
                    break;
                }
            }*/
            this.questions.filter(item => {
                console.log(item)
                console.log(item.id_tmp, ' == ', item_id)
                if(item.id && parseInt(item.id_tmp) === parseInt(item_id)) {
                    console.log('deleting item: ', item_id)
                    item.delete = 1
                }
            })
            // el.remove()
        },
        sendProject() {
            this.status = 'send'
            this.fetchProject()
            setTimeout(() => {
                location.reload();
            }, 1000)
        },
        addItem() {
            this.count += 1;
            this.items.push(this.count)
            let it = document.getElementById(`item-${this.items[this.items.length - 2]}`);
            if (!it) {
                it = document.getElementById(`item-0`);
            }
            this.questions.push({
                'id_tmp': this.count,
                'id': '',
                'title': '',
                'answer': '',
                'delete': 0,
            });
            let i = document.createElement('div')
            i.setAttribute("class", "col-12");
            i.setAttribute("id", `item-${this.count}`);
            /*i.innerHTML = `
                        <div class="element-box bg-item">
                            <button class="close btn-delete-item" type="button" onclick="removeItem(${this.count})">
                                <span class="os-icon os-icon-close"></span>
                            </button>
                            <div class="form-group">
                                <label for="">Item #${this.count}</label>
                                <input class="form-control"
                                        name="title-${this.count}"
                                        id="title-${this.count}"
                                        placeholder="Agrega el contenido de tu pregunta"
                                        maxlength="255"
                                        type="text">
                            </div>
                            <div class="row">
                                <div class="col-sm-12">
                                    <h5 class="form-header">
                                        Respuesta
                                    </h5>
                                    <div class="form-desc">
                                        Agrega tu respuesta
                                    </div>
                                    <textarea cols="80" id="answer-${this.count}" name="answer-${this.count}"
                                              rows="10"></textarea>
                                </div>
                            </div>
                        </div>
                    `;*/

            // it.insertAdjacentElement("afterend", i);
            setTimeout(()=>{
                if ($(`#answer-${this.count}`).length) {
                    CKEDITOR.replace(`answer-${this.count}`);
                }
            }, 1000)
        }
    }
})

app.mount('#app')

    </script>


{% endblock %}

writer/templates/writer/sidebar-left.html
{% load static %}

<!-------------------- START - Mobile Menu  -------------------->
<div class="menu-mobile menu-activated-on-click color-scheme-dark">
    <div class="mm-logo-buttons-w">
        <a class="mm-logo" href="{% url 'writer:projects' %}">
            <img src="{% static 'img/logo.png' %}">
            <span>{{ request.user.username }}</span>
        </a>
        <div class="mm-buttons">
            <div class="content-panel-open">
                <div class="os-icon os-icon-grid-circles"></div>
            </div>
            <div class="mobile-menu-trigger">
                <div class="os-icon os-icon-hamburger-menu-1"></div>
            </div>
        </div>
    </div>
    <div class="menu-and-user">
        <div class="logged-user-w">
            <div class="avatar-w">
                <a href="{% url 'writer:projects' %}">
                    <img alt="" src="{% static 'img/avatar1.jpg' %}">
                </a>
            </div>
            <div class="logged-user-info-w">
                <div class="logged-user-name">
                    {{ request.user.full_name }}
                </div>
                <div class="logged-user-role">
                    {{ request.user.get_role }}
                </div>
            </div>
        </div>
        <!--------------------
        START - Mobile Menu List
        -------------------->
        <ul class="main-menu">
            {% include 'writer/menu.html' %}
        </ul>
        <!--------------------
        END - Mobile Menu List
        -------------------->
    </div>
</div>
<!-------------------- END - Mobile Menu-------------------->

<!--------------------  START - Menu side -------------------->
<div class="desktop-menu menu-side-w menu-activated-on-click" id="desktop-menu">
    <div class="logo-w">
        <a class="logo" href="{% url 'writer:projects' %}">
            <div class="logo-element"></div>
            <div class="logo-label">
                {{ request.user.username }}
            </div>
        </a>
    </div>
    <div class="menu-and-user">
        <div class="logged-user-w">
            <div class="logged-user-i">
                <div class="avatar-w">
                    <a href="{% url 'writer:projects' %}">
                        <img alt="" src="{% static 'img/avatar1.jpg' %}">
                    </a>
                </div>
                <div class="logged-user-info-w">
                    <div class="logged-user-name">
                        {{ request.user.full_name }}
                    </div>
                    <div class="logged-user-role">
                        {{ request.user.get_role }}
                    </div>
                </div>
            </div>
        </div>
        <ul class="main-menu">
            {% include 'writer/menu.html' %}
        </ul>
    </div>
</div>
<!-------------------- END - Menu side -------------------->

writer/templates/writer/step_end.html
<div id="stepContent2" v-show="step=={{ step }}">
    <h4 class="todo-content-header text-center">
        <i class="os-icon os-icon-ui-83"></i>
        <span>
            Estás a un paso de enviar tu proyecto para que una persona experta evalúe tu proyecto.
        </span>
    </h4>
    <div class="form-buttons-w text-center">
        <button class="btn btn-secondary"
                @click="changeStep(3)">
            Volver
        </button>
        <button @click="sendProject" class="btn btn-primary step-trigger-btn">
            Enviar
        </button>
    </div>
</div>